scoreboard players add @s age 1

tag @s add self

execute if entity @s[scores={age=1}] run playsound minecraft:entity.evoker.cast_spell master @a ~ ~ ~ 1 .9

execute if entity @s[tag=lockedon] run tp @s @e[limit=1,sort=nearest,tag=anvilPath,distance=..5]
execute unless entity @e[distance=..5,tag=anvilPath] run tag @s remove lockedon
execute if entity @s[tag=lockedon] run kill @e[limit=1,sort=nearest,tag=anvilPath,distance=..5]

#locked-on anvils can collide in mid-air, preventing a bug where they merge together on the same path
execute if entity @e[tag=anvil,tag=lockedon,tag=!self,distance=..1] run tag @e[distance=..1,tag=anvil,tag=lockedon] add impact

#still locked on, impact after a few seconds
tag @s[tag=lockedon,tag=!impacted,scores={age=78..}] add anvilLinger
tag @s[tag=lockedon,tag=!impacted,scores={age=78..}] add impact

#free-falling anvil will terminate if it's been falling for too long
tag @s[tag=!lockedon,tag=!impacted,scores={age=250..}] add impact

#not locked on, impact when the ground is touched
tag @s[tag=!lockedon,tag=!impacted,nbt={OnGround:1b}] add anvilLinger
tag @s[tag=!lockedon,tag=!impacted,nbt={OnGround:1b}] add impact

tag @s remove self

#impact and damage nearby players (can only happen once!)
execute if entity @s[tag=impact,tag=!impacted] run tp @s ~ ~-1 ~
execute if entity @s[tag=impact,tag=!impacted] run playsound minecraft:block.anvil.land master @a ~ ~ ~ 2 .8
execute if entity @s[tag=impact,tag=!impacted] run particle minecraft:block anvil ~ ~1.4 ~ 0.4 0.2 0.4 1 25 force
execute if entity @s[tag=impact,tag=!impacted,tag=anvilLinger] run scoreboard players set @s lifespan 10
execute if entity @s[tag=impact,tag=!impacted,tag=!anvilLinger] run scoreboard players set @s lifespan 2
execute if entity @s[tag=impact,tag=!impacted] run kill @e[tag=chickenmine,distance=..2]
execute if entity @s[tag=impact,tag=!impacted] run effect give @e[distance=..2,tag=activeplayer,scores={invisibility=..0}] resistance 1 0 true
execute if entity @s[tag=impact,tag=!impacted] run effect give @e[distance=..2,tag=activeplayer,scores={invisibility=..0,resistTime=1..}] resistance 1 2 true
execute if entity @s[tag=impact,tag=!impacted] run effect give @e[distance=..2,tag=activeplayer,type=!zombie,scores={invisibility=..0}] instant_damage 1 1 true
execute if entity @s[tag=impact,tag=!impacted] run effect give @e[distance=..2,tag=activeplayer,type=zombie,scores={invisibility=..0}] instant_health 1 1 true
execute if entity @s[tag=impact,tag=!impacted] run scoreboard players set @e[distance=..2,tag=activeplayer,scores={invisibility=..0,resistTime=..0}] moveSpeed 0
execute if entity @s[tag=impact,tag=!impacted] run scoreboard players operation @e[distance=..2,tag=activeplayer,scores={invisibility=..0}] attackerID = @s playerID
execute if entity @s[tag=impact,tag=!impacted] run scoreboard players set @e[distance=..2,tag=activeplayer,scores={invisibility=..0}] attackTime 100
execute if entity @s[tag=impact,tag=!impacted] run tag @s add impacted

#poof after death
execute if entity @s[tag=anvilLinger,scores={lifespan=1}] run particle cloud ~ ~1.5 ~ 0.3 0.3 0.3 0 20